/*
////////////////////////////////////////////////////////////////////////////////
//
// Copyright 2012, Reinhold Schaaf,
// Argelander-Institut fuer Astronomie
// Universitaet Bonn
// rschaaf@astro.uni-bonn.de
//
// For further info about copyright and license see included license.txt file
//
////////////////////////////////////////////////////////////////////////////////
*/

#include "icModellib.h"


/******************************************************************************/

void
density(double x, double y, double z, double *density){	
	density[0] = modellibDensity(x, y, z);
}

/******************************************************************************/

void
temperature(double x, double y, double z, double *temperature){
	temperature[0] = modellibTemperature(x, y, z);
	temperature[1] = modellibTdust(x, y, z);
}

/******************************************************************************/

void
abundance(double x, double y, double z, double *abundance){
  abundance[0] = modellibAbundance(x, y, z);
}

/******************************************************************************/

void
doppler(double x, double y, double z, double *doppler){
  *doppler = modellibDoppler(x, y, z);
}

/******************************************************************************/

void
velocity(double x, double y, double z, double *vel){
	modellibVelocity(x, y, z, vel);
}

/******************************************************************************/

void
magfield(double x, double y, double z, double *bmag){
	modellibBmag(x, y, z, bmag);
}

/******************************************************************************/
