////////////////////////////////////////////////////////////////////////////////
//
// Copyright 2012, Reinhold Schaaf
// Argelander-Institut fuer Astronomie
// Universitaet Bonn
// rschaaf@astro.uni-bonn.de
//
// and the ARTIST team.
//
// For further info about copyright and license see included license.txt file.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef FUNCTIONTAB_H
#define FUNCTIONTAB_H

#include <vector>

#include "functionScalar.h"
#include "functionVector.h"
#include "artistTabdataReader.h"

using namespace std;

class FS_Tabdata: public FunctionScalar
{
public:
  static string functionID;

  FS_Tabdata();
  virtual ~FS_Tabdata();

  virtual const FunctionReg getFunctionReg();
  virtual const set<string> getParamIDs();
  virtual const ParamReg* getParamReg(string paramID);

  virtual const double value(const double x, const double y, const double z);

protected:
  virtual void onFinalizeConfiguration();

private:
  ScalarTabdataReader* m_pReader;
  double m_defValue;
};


class FV_Tabdata: public FunctionVector
{
public:
  static string functionID;

  FV_Tabdata();
  virtual ~FV_Tabdata();

  virtual const FunctionReg getFunctionReg();
  virtual const set<string> getParamIDs();
  virtual const ParamReg* getParamReg(string paramID);

  virtual const void value(const double x, const double y, const double z, double* val);

protected:
  virtual void onFinalizeConfiguration();

private:
  VectorTabdataReader* m_pReader;
};




#endif // FUNCTIONTAB_H
