////////////////////////////////////////////////////////////////////////////////
//
// Copyright 2012, Attila Juhasz
// Sterrewacht Leiden
// Universiteit Leiden
// juhasz@strw.leidenuniv.nl
//
// and the ARTIST team.
//
// For further info about copyright and license see included license.txt file.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef MODEL_BonnorEbert56_H
#define MODEL_BonnorEbert56_H

#include "model.h"

#include <set>

class ModelBonnorEbert56 : public Model,
public IDensityProvider,
public ITemperatureProvider,
public IVelocityProvider
{
  // Model interface:
public:
  ModelBonnorEbert56();
  virtual ~ModelBonnorEbert56();

  static string modelID;
  const ModelReg getModelReg();
  const set<string> getParamIDs();
  const ParamReg* getParamReg(string paramID);

protected:
  virtual void onFinalizeConfiguration();

  // IProvider interfaces:
public:
  virtual const double
  density(const double x, const double y, const double z);

  virtual const double
  temperature(const double x, const double y, const double z);

  virtual const void
  velocity(const double x, const double y, const double z, double* v);
private:
  double m_rhoc;
  double m_T;
};

#endif //MODEL_BonnorEbert56_H
