#ifndef MODEL_LISHU96_H
#define MODEL_LISHU96_H

#include "model.h"

#include <set>

class ModelLiShu96 : public Model,
public IDensityProvider,
public IBmagProvider,
public IVelocityProvider,
public ITemperatureProvider
{
  // Model interface:
public:
  ModelLiShu96();
  virtual ~ModelLiShu96();

  static string modelID;
  const ModelReg getModelReg();
  const set<string> getParamIDs();
  const ParamReg* getParamReg(string paramID);

protected:
  virtual void onFinalizeConfiguration();

  // IProvider interfaces:
public:
  virtual const double
  density(const double x, const double y, const double z);

  virtual const void
  bmag(const double x, const double y, const double z, double* b);
  
  virtual const void
  velocity(const double x, const double y, const double z, double* v);
  
  virtual const double
  temperature(const double x, const double y, const double z);

private:
  double m_cs;
  unsigned m_h0Index;
};

#endif //MODEL_LISHU96_H
