////////////////////////////////////////////////////////////////////////////////
//
// Copyright 2012, Reinhold Schaaf
// Argelander-Institut fuer Astronomie
// Universitaet Bonn
// rschaaf@astro.uni-bonn.de
//
// and the ARTIST team.
//
// For further info about copyright and license see included license.txt file.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef MODELMAMONINTERPOL_H
#define MODELMAMONINTERPOL_H

using namespace std;

// Functions to perform interpolation of values from table 3 in Mamon et al.:

#include <vector>

const double getAlpha(const double mdot, const double ve);
const double getRhalf(const double mdot, const double ve);
const vector<double> logMdotTable();
const vector<double> veTable();
const double bilinearInterpol(const double& x,
							  const double& y,
							  const vector<double>& xgrid,
							  const vector<double>& xygrid,
							  const vector< vector<double> > zgrid);

#endif // MODELMAMONINTERPOL_H
