////////////////////////////////////////////////////////////////////////////////
//
// Copyright 2012, Attila Juhasz
// Sterrewacht Leiden
// Universiteit Leiden
// juhasz@strw.leidenuniv.nl
//
// and the ARTIST team.
//
// For further info about copyright and license see included license.txt file.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef MODEL_SHU77_H
#define MODEL_SHU77_H

#include "model.h"

#include <set>

class ModelShu77 :
public Model,
public IDensityProvider,
public ITemperatureProvider,
public ITdustProvider,
public IVelocityProvider
{
  // Model interface:
public:
  ModelShu77();
  virtual ~ModelShu77();

  static string modelID;
  const ModelReg getModelReg();
  const set<string> getParamIDs();
  const ParamReg* getParamReg(string paramID);

protected:
  virtual void onFinalizeConfiguration();

  // IProvider interfaces:
public:
  virtual const double
  density(const double x, const double y, const double z);

  virtual const double
  temperature(const double x, const double y, const double z);

  virtual const double
  t_dust(const double x, const double y, const double z);

  virtual const void
  velocity(const double x, const double y, const double z, double* v);

private:
  double m_T;
  double m_time;
};
#endif //MODEL_SHU77_H
