////////////////////////////////////////////////////////////////////////////////
//
// Copyright 2012, Attila Juhasz
// Sterrewacht Leiden
// Universiteit Leiden
// juhasz@strw.leidenuniv.nl
//
// and the ARTIST team.
//
// For further info about copyright and license see included license.txt file.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef MODEL_Ulrich76_H
#define MODEL_Ulrich76_H

#include "model.h"

#include <set>

class ModelUlrich76 : public Model,
public IDensityProvider,
public IVelocityProvider
{
  // Model interface:
public:
  ModelUlrich76();
  virtual ~ModelUlrich76();

  static string modelID;
  const ModelReg getModelReg();
  const set<string> getParamIDs();
  const ParamReg* getParamReg(string paramID);

protected:
  virtual void onFinalizeConfiguration();

  // IProvider interfaces:
public:
  virtual const double
  density(const double x, const double y, const double z);

  virtual const void
  velocity(const double x, const double y, const double z, double* v);


private:
  double m_mdot;
  double m_mstar;
  double m_rc;
  double m_x;
  double m_doppler_b;
};

#endif //MODEL_Ulrich76_H
