////////////////////////////////////////////////////////////////////////////////
//
// Copyright 2012, Reinhold Schaaf
// Argelander-Institut fuer Astronomie
// Universitaet Bonn
// rschaaf@astro.uni-bonn.de
//
// and the ARTIST team.
//
// For further info about copyright and license see included license.txt file.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef TABLEREADER_H
#define TABLEREADER_H

#include <string>
#include <vector>
#include <map>

using namespace std;

class TableReader
{
public:
	TableReader(const string filename);
	virtual ~TableReader();

	vector<double>& read(const int icol);

private:

	void stripComment(string& line) const;
	int countWords(const string& line) const;
	vector<double> parseLine(string line) const;
	void parseFile();


	string m_filename;

	map<int, vector<double> > m_vals;
	bool m_fileParsed;

	const static string m_comment;
	const static string m_wordsep;

};

#endif // TABLEREADER_H
