import modellib


try:
    for modelID in modellib.getModelIDs():
        print "Model:"
        print "\t%s"*4 % (modelID,
                          modellib.getModelName(modelID),
                          modellib.getModelDesc(modelID),
                          modellib.getModelBibref(modelID))

        print "Parameters:"
        paramIDs = modellib.getParamIDs(modelID)
        for paramID in paramIDs:
            print "\t%s"*4 % (paramID,
                              modellib.getParamType(modelID, paramID),
                              modellib.getParamName(modelID, paramID),
                              modellib.getParamDesc(modelID, paramID)),
            if modellib.getParamType(modelID, paramID) == "double":
                print "\t%s"*2 % (modellib.getParamUnit(modelID, paramID),
                                  modellib.getParamDefValDouble(modelID, paramID))
            elif modellib.getParamType(modelID, paramID) == "int":
                print "\t%s" % (modellib.getParamDefValInt(modelID, paramID))
            elif modellib.getParamType(modelID, paramID) == "string":
                print "\t%s" % (modellib.getParamDefValString(modelID, paramID))
            elif modellib.getParamType(modelID, paramID) == "enum":
                print "\t%s"*2 % (modellib.getParamUnit(modelID, paramID),
                                  modellib.getParamEnumDefIndex(modelID, paramID)),
                print modellib.getParamEnumValues(modelID, paramID)
            else:
                print "** Invalid type **"
                
        print "Results:"    
        resultIDs = modellib.getModelResultIDs(modelID)
        for resultID in resultIDs:
            print "\t%s"*5 % (resultID,
                              modellib.getResultName(resultID),
                              modellib.getResultDesc(resultID),
                              modellib.getResultUnit(resultID),
                              modellib.getResultType(resultID))

        print "----"

    
    for functionID in modellib.getFunctionIDs():
        print "Function:"
        print "\t%s"*3 % (functionID,
                          modellib.getFunctionName(functionID),
                          modellib.getFunctionType(functionID))
        print
        print modellib.getFunctionDesc(functionID)
        print

        print "Parameters:"
        paramIDs = modellib.getFunctionParamIDs(functionID)
        for paramID in paramIDs:
            print "\t%s"*4 % (paramID,
                              modellib.getFunctionParamType(functionID, paramID),
                              modellib.getFunctionParamName(functionID, paramID),
                              modellib.getFunctionParamDesc(functionID, paramID)),
            if modellib.getFunctionParamType(functionID, paramID) == "double":
                print "\t%s" % (modellib.getFunctionParamDefValDouble(functionID, paramID))
            elif modellib.getFunctionParamType(functionID, paramID) == "int":
                print "\t%s" % (modellib.getFunctionParamDefValInt(functionID, paramID))
            elif modellib.getFunctionParamType(functionID, paramID) == "string":
                print "\t%s" % (modellib.getFunctionParamDefValString(functionID, paramID))
            elif modellib.getFunctionParamType(functionID, paramID) == "enum":
                print "\t%s" % (modellib.getFunctionParamEnumDefIndex(functionID, paramID)),
                print modellib.getFunctionParamEnumValues(functionID, paramID)
            else:
                print "** Invalid type **"
                
        print "----"




    print "Configuration:"
    modelID = "BonnorEbert56"
    modellib.setCurrentModel(modelID)
    modellib.setParamDouble("T", 100.)
    modellib.setParamDouble("rhoc", 1.e5)

    for resultID in modellib.getResultIDs():
        if not modellib.isResultModel(resultID, modelID):
            if modellib.getResultType(resultID) == 'scalar':
                modellib.setFunction(resultID, 'scalarConst')
            else:
                modellib.setFunction(resultID, 'vectorConstR')

    modellib.finalizeConfiguration()

    print "Usage:"
    print "Density BonnorEbert56: %.3e" % modellib.density(3.e14, 3.e14, 3.e14)

except Exception, e:
    print "Exception: ", e
