import modellib

print
print "Model without t_dust"
modellib.setCurrentModel("shuCollapseAnalytic")
modellib.setParamDouble("r0", 1.e13)
modellib.setParamDouble("n0", 1.e9)
modellib.setParamDouble("T0", 100.)
modellib.setParamDouble("MStar", 1.e33)
modellib.finalizeConfiguration()

print
print "Default: t_dust identical with temperature:"
print modellib.isTdustIdentTemp(), " (True)"
print modellib.isCurrentResultModel("tdust"), " (False)"
print modellib.isCurrentResultFunction("tdust"), " (False)"

print modellib.temperature(1.e13, 0., 0.), " (100.)"
print modellib.t_dust(1.e13, 0., 0.), " (100.)"

print
print "Set temperature to Function:"
modellib.setFunction("temperature", "scalarConst")
modellib.setFunctionParamDouble("temperature", "val", 42.)
modellib.finalizeConfiguration()

print modellib.isTdustIdentTemp(), " (True)"
print modellib.isCurrentResultModel("tdust"), " (False)"
print modellib.isCurrentResultFunction("tdust"), " (False)"

print modellib.temperature(1.e13, 0., 0.), " (42.)"
print modellib.t_dust(1.e13, 0., 0.), " (42.)"

print
print "Set t_dust to Function:"
modellib.setFunction("tdust", "scalarConst")
modellib.setFunctionParamDouble("tdust", "val", 13.)
modellib.finalizeConfiguration()

print modellib.isTdustIdentTemp(), " (False)"
print modellib.isCurrentResultModel("tdust"), " (False)"
print modellib.isCurrentResultFunction("tdust"), " (True)"

print modellib.temperature(1.e13, 0., 0.), " (42.)"
print modellib.t_dust(1.e13, 0., 0.), " (13.)"

print
print "Set temperature to Model:"
modellib.unsetFunction("temperature")
modellib.finalizeConfiguration()

print modellib.isTdustIdentTemp(), " (False)"
print modellib.isCurrentResultModel("tdust"), " (False)"
print modellib.isCurrentResultFunction("tdust"), " (True)"

print modellib.temperature(1.e13, 0., 0.), " (100.)"
print modellib.t_dust(1.e13, 0., 0.), " (13.)"

print
print "Identify tdust with temperature:"
modellib.setTdustIdentTemp()
modellib.finalizeConfiguration()

print modellib.isTdustIdentTemp(), " (True)"
print modellib.isCurrentResultModel("tdust"), " (False)"
print modellib.isCurrentResultFunction("tdust"), " (False)"

print modellib.temperature(1.e13, 0., 0.), " (100.)"
print modellib.t_dust(1.e13, 0., 0.), " (100.)"

print
print "Model with t_dust"
modellib.setCurrentModel("BonnorEbert56")
modellib.setParamDouble("rhoc", 1.e13)
modellib.setParamDouble("T", 100.)
modellib.finalizeConfiguration()

print
print "Default: t_dust not identical with temperature:"
print modellib.isTdustIdentTemp(), " (False)"
print modellib.isCurrentResultModel("tdust"), " (True)"
print modellib.isCurrentResultFunction("tdust"), " (False)"

print modellib.temperature(1.e13, 0., 0.), " (100.)"
print modellib.t_dust(1.e13, 0., 0.), " (100.)"

print
print "Identify tdust with temperature:"
modellib.setTdustIdentTemp()
modellib.finalizeConfiguration()

print modellib.isTdustIdentTemp(), " (True)"
print modellib.isCurrentResultModel("tdust"), " (False)"
print modellib.isCurrentResultFunction("tdust"), " (False)"

print modellib.temperature(1.e13, 0., 0.), " (100.)"
print modellib.t_dust(1.e13, 0., 0.), " (100.)"


print
print "Set t_dust to Function:"
modellib.setFunction("tdust", "scalarConst")
modellib.setFunctionParamDouble("tdust", "val", 13.)
modellib.finalizeConfiguration()

print modellib.isTdustIdentTemp(), " (False)"
print modellib.isCurrentResultModel("tdust"), " (False)"
print modellib.isCurrentResultFunction("tdust"), " (True)"

print modellib.temperature(1.e13, 0., 0.), " (100.)"
print modellib.t_dust(1.e13, 0., 0.), " (13.)"

print
print "Identify tdust with temperature:"
modellib.setTdustIdentTemp()
modellib.finalizeConfiguration()

print modellib.isTdustIdentTemp(), " (True)"
print modellib.isCurrentResultModel("tdust"), " (False)"
print modellib.isCurrentResultFunction("tdust"), " (False)"

print modellib.temperature(1.e13, 0., 0.), " (100.)"
print modellib.t_dust(1.e13, 0., 0.), " (100.)"

print
print "Set temperature to Function:"
modellib.setFunction("temperature", "scalarConst")
modellib.setFunctionParamDouble("temperature", "val", 42.)
modellib.finalizeConfiguration()

print modellib.isTdustIdentTemp(), " (True)"
print modellib.isCurrentResultModel("tdust"), " (False)"
print modellib.isCurrentResultFunction("tdust"), " (False)"

print modellib.temperature(1.e13, 0., 0.), " (42.)"
print modellib.t_dust(1.e13, 0., 0.), " (42.)"

print
print "Unidentify tdust and temperature:"
modellib.unsetTdustIdentTemp()
modellib.finalizeConfiguration()

print modellib.isTdustIdentTemp(), " (False)"
print modellib.isCurrentResultModel("tdust"), " (True)"
print modellib.isCurrentResultFunction("tdust"), " (False)"

print modellib.temperature(1.e13, 0., 0.), " (42.)"
print modellib.t_dust(1.e13, 0., 0.), " (100.)"




